// BobControlCtl.cpp : Implementation of the CBobControlCtrl OLE control class.

#include "stdafx.h"
#include "BobControl.h"
#include "BobControlCtl.h"
#include "BobControlPpg.h"
#include "LastNamePropPage.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CBobControlCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CBobControlCtrl, COleControl)
	//{{AFX_MSG_MAP(CBobControlCtrl)
	// NOTE - ClassWizard will add and remove message map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CBobControlCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CBobControlCtrl)
	DISP_PROPERTY_NOTIFY(CBobControlCtrl, "LastName", m_lastName, OnLastNameChanged, VT_BSTR)
	DISP_PROPERTY_EX(CBobControlCtrl, "FirstName", GetFirstName, SetFirstName, VT_I2)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CBobControlCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CBobControlCtrl, COleControl)
	//{{AFX_EVENT_MAP(CBobControlCtrl)
	// NOTE - ClassWizard will add and remove event map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CBobControlCtrl, 2)
	PROPPAGEID(CBobControlPropPage::guid)
	PROPPAGEID(CLastNamePropPage::guid)
END_PROPPAGEIDS(CBobControlCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CBobControlCtrl, "BOBCONTROL.BobControlCtrl.1",
	0x526379b5, 0x53e6, 0x11cf, 0x80, 0x64, 0x5a, 0xd6, 0x90, 0xc, 0, 0)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CBobControlCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DBobControl =
		{ 0x526379b3, 0x53e6, 0x11cf, { 0x80, 0x64, 0x5a, 0xd6, 0x90, 0xc, 0, 0 } };
const IID BASED_CODE IID_DBobControlEvents =
		{ 0x526379b4, 0x53e6, 0x11cf, { 0x80, 0x64, 0x5a, 0xd6, 0x90, 0xc, 0, 0 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwBobControlOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CBobControlCtrl, IDS_BOBCONTROL, _dwBobControlOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CBobControlCtrl::CBobControlCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CBobControlCtrl

BOOL CBobControlCtrl::CBobControlCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_BOBCONTROL,
			IDB_BOBCONTROL,
			FALSE,                      //  Not insertable
			_dwBobControlOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CBobControlCtrl::CBobControlCtrl - Constructor

const TCHAR * const g_szBobs[] = { _T("Bob"), _T("Bobby"), _T("Robert") };

CBobControlCtrl::CBobControlCtrl()
: m_bobBobbyRobert(BOB)
{
	InitializeIIDs(&IID_DBobControl, &IID_DBobControlEvents);

	// TODO: Initialize your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CBobControlCtrl::~CBobControlCtrl - Destructor

CBobControlCtrl::~CBobControlCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CBobControlCtrl::OnDraw - Drawing function

void CBobControlCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	// TODO: Replace the following code with your own drawing code.
	pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
	CString s = _T("Hello, I am ");
    s += g_szBobs[m_bobBobbyRobert];
    s += _T(" ");
    s += m_lastName;
    pdc->DrawText(s, LPRECT(&rcBounds), DT_SINGLELINE|DT_VCENTER|DT_CENTER);
}


/////////////////////////////////////////////////////////////////////////////
// CBobControlCtrl::DoPropExchange - Persistence support

void CBobControlCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.

    PX_String(pPX, _T("LastName"), m_lastName, _T("Smith"));
    PX_Short(pPX, _T("FirstName"), m_bobBobbyRobert, BOB);
}


/////////////////////////////////////////////////////////////////////////////
// CBobControlCtrl::OnResetState - Reset control to default state

void CBobControlCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CBobControlCtrl::AboutBox - Display an "About" box to the user

void CBobControlCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_BOBCONTROL);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CBobControlCtrl message handlers

void CBobControlCtrl::OnLastNameChanged() 
{
    if (!AmbientUserMode())
        BoundPropertyChanged(dispidLastName);
    InvalidateControl();
	SetModifiedFlag();
}

BOOL 
CBobControlCtrl::OnGetDisplayString(DISPID dispid, 
                                    CString& strValue)
{
// default to use native property
    BOOL result = FALSE; 
    switch (dispid)
    {
    case dispidFirstName:
// update display string and indicate that we did it
        strValue = g_szBobs[m_bobBobbyRobert];
        result = TRUE;
        break;
    case dispidLastName:
// update display string and indicate that we did it
        strValue = m_lastName;
        result = TRUE;
        break;
    default:
// allow base class to perform mappings
        result = COleControl::OnGetDisplayString(dispid, strValue);
    }
    return result;
}

BOOL 
CBobControlCtrl::OnGetPredefinedStrings(DISPID dispid, 
                                        CStringArray* pStringArray, 
                                        CDWordArray* pCookieArray)
{
// default to use native editor
    BOOL result = FALSE; 
    switch (dispid)
    {
    case dispidFirstName:
// update string and cookie arrays and indicate that we did it
        pStringArray->Add(g_szBobs[BOB]);
        pCookieArray->Add(BOB);
        pStringArray->Add(g_szBobs[BOBBY]);
        pCookieArray->Add(BOBBY);
        pStringArray->Add(g_szBobs[ROBERT]);
        pCookieArray->Add(ROBERT);
        result = TRUE;
        break;
    default:
// allow base class to perform mappings
        result = COleControl::OnGetPredefinedStrings(dispid, 
                                                     pStringArray,
                                                     pCookieArray);
    }
    return result;
}

BOOL 
CBobControlCtrl::OnGetPredefinedValue(DISPID dispid, 
                                      DWORD dwCookie, 
                                      VARIANT FAR* lpvarOut)
{
// default to no mapping
    BOOL result = FALSE; 
    switch (dispid)
    {
    case dispidFirstName:
// map dwCookie to the name and indicate that we did it
        VariantInit(lpvarOut);
        lpvarOut->vt = VT_I2;
        lpvarOut->iVal = short(dwCookie);
        result = TRUE;
        break;
    default:
// allow base class to perform mappings
        result = COleControl::OnGetPredefinedValue(dispid, 
                                                   dwCookie, 
                                                   lpvarOut);
    }
    return result;
}


BOOL 
CBobControlCtrl::OnMapPropertyToPage(DISPID dispid, 
                                     LPCLSID lpclsid, 
                                     BOOL* pbPageOptional)
{
// default to no mapping
    BOOL result = FALSE; 
    switch (dispid)
    {
    case dispidLastName:
// map dwCookie to the name and indicate that we did it
        *lpclsid = CLastNamePropPage::guid;
        *pbPageOptional = FALSE;
        result = TRUE;
        break;
    default:
// allow base class to perform mappings
        result = COleControl::OnMapPropertyToPage(dispid, 
                                                  lpclsid, 
                                                  pbPageOptional);
    }
    return result;
}

short CBobControlCtrl::GetFirstName() 
{
	return m_bobBobbyRobert;
}

void CBobControlCtrl::SetFirstName(short nNewValue) 
{
    if (nNewValue > 2 || nNewValue < 0)
        AfxThrowOleDispatchException(42, 
                _T("You tried to defeat my Bob-ness.")); 
    m_bobBobbyRobert = nNewValue;
    if (!AmbientUserMode())
        BoundPropertyChanged(dispidFirstName);
	InvalidateControl();
    SetModifiedFlag();
}
