////////////////////////////////////////////////////////////////////////////////
// $Header:   S:\3x\src\ntkm\ntdevpp\sampdrv\debug.cpv   1.0   24 Jun 1996 16:24:24   JHUCKINS  $
// 
// INTEL Corporation Proprietary Information
// 
// This listing is supplied under the terms of a license agreement
// with INTEL Corporation and may not be copied nor disclosed except
// in accordance with the terms of that agreement.
// 
// Copyright (c) 1996 Intel Corporation. All rights reserved.
// 
// $Revision:   1.0  $
// $Date:   24 Jun 1996 16:24:24  $
// $Author:   JHUCKINS  $
// 
// Log at end of file.
// 
// Module Name:		debug.cpp
// Abstract:		debug support
// Environment:		Windows NT 3.51/4.0, MS Visual C++ 2.x
// Notes:
// 
////////////////////////////////////////////////////////////////////////////////

// disable some warnings
#pragma warning( disable: 4699 )	// Note: Creating precompiled header
#pragma warning( disable: 4201 )	// nameless struct/union
#pragma warning( disable: 4514 )	// unreferenced inline function has been removed

#include "debug.h"

#ifdef _DEBUG

#include <stdio.h>
#include <stdarg.h>
extern char szDebugName[];
void __cdecl _DebugPrint( char* pFormat, ... )
{
	// format user message
	static char buffer1[ 196 ];
	va_list arg_ptr;
	va_start( arg_ptr, pFormat );
	vsprintf( buffer1, pFormat, arg_ptr );

	// add device name and newline
	static char buffer2[ 256 ];
	sprintf( buffer2, "%s: %s\n", szDebugName, buffer1 );

	// add newline
	DbgPrint( buffer2 );

	return;
}

#else

void __cdecl _DebugPrint( char*, ... )
{
	return;
}

#endif

///////////////////////////////////////////////////////////////////////////////
// $Log:   S:\3x\src\ntkm\ntdevpp\sampdrv\debug.cpv  $
// 
//    Rev 1.0   24 Jun 1996 16:24:24   JHUCKINS
// Initial revision.
// 
//    Rev 1.2   31 May 1996 15:49:40   JDELLIOT
// added robustness features (ASSERT, TRACE, validation of params)
// cleanup
// restructure of some interfaces
// 
//    Rev 1.1   27 Mar 1996 14:12:44   JDELLIOT
// added PVCS keywords and support for warning level 4
// 
//    Rev 1.0   22 Mar 1996 18:45:00   JDELLIOT
// Initial revision.
//

