////////////////////////////////////////////////////////////////////////////////
// $Header:   S:\3x\src\ntkm\ntdevpp\sampdrv\debug.h_v   1.0   24 Jun 1996 16:24:30   JHUCKINS  $
// 
// INTEL Corporation Proprietary Information
// 
// This listing is supplied under the terms of a license agreement
// with INTEL Corporation and may not be copied nor disclosed except
// in accordance with the terms of that agreement.
// 
// Copyright (c) 1996 Intel Corporation. All rights reserved.
// 
// $Revision:   1.0  $
// $Date:   24 Jun 1996 16:24:30  $
// $Author:   JHUCKINS  $
// 
// Log at end of file.
// 
// Module Name:		debug.h
// Abstract:		debug support
// Environment:		Windows NT 3.51/4.0, MS Visual C++ 2.x
// Notes:
// 
////////////////////////////////////////////////////////////////////////////////

#ifndef debug_h
#define debug_h

extern "C"
{
#include <ntddk.h>
}

void __cdecl _DebugPrint( char* pFormat, ... );

// IRQL asserts
#define ASSERT_IRQL_LT( x )	ASSERT( ::KeGetCurrentIrql() < (x) )
#define ASSERT_IRQL_LE( x )	ASSERT( ::KeGetCurrentIrql() <= (x) )
#define ASSERT_IRQL_EQ( x )	ASSERT( ::KeGetCurrentIrql() == (x) )
#define ASSERT_IRQL_GE( x )	ASSERT( ::KeGetCurrentIrql() >= (x) )
#define ASSERT_IRQL_GT( x )	ASSERT( ::KeGetCurrentIrql() > (x) )

#ifdef _DEBUG

// general macros
#define VERIFY( s )		ASSERT( s )
#define DEBUG_INT( x )	_asm int x
#define TRACE			::_DebugPrint

#else

#pragma warning( disable: 4705 )	// statement has no effect

// general macros
#define VERIFY( s ) 	s
#define DEBUG_INT( x )	0
#define TRACE			1 ? void( 0 ) : ::_DebugPrint

#endif

#endif debug_h

/******************************************************************************
 * $Log:   S:\3x\src\ntkm\ntdevpp\sampdrv\debug.h_v  $
 * 
 *    Rev 1.0   24 Jun 1996 16:24:30   JHUCKINS
 * Initial revision.
 * 
 *    Rev 1.3   08 May 1996 17:33:58   JDELLIOT
 * fixed bugs in ASSERT_IRQL_xx macros
 * 
 *    Rev 1.2   29 Apr 1996 17:29:14   JDELLIOT
 * fixed typo
 * 
 *    Rev 1.1   25 Apr 1996 14:05:42   JDELLIOT
 * added ASSERT_IRQL_XX macros
 * 
 *    Rev 1.0   22 Mar 1996 18:45:02   JDELLIOT
 * Initial revision.
 * 
 */
