////////////////////////////////////////////////////////////////////////////////
// $Header:   S:\3x\src\ntkm\ntdevpp\sampdrv\deventry.h_v   1.0   24 Jun 1996 16:24:32   JHUCKINS  $
// 
// INTEL Corporation Proprietary Information
// 
// This listing is supplied under the terms of a license agreement
// with INTEL Corporation and may not be copied nor disclosed except
// in accordance with the terms of that agreement.
// 
// Copyright (c) 1996 Intel Corporation. All rights reserved.
// 
// $Revision:   1.0  $
// $Date:   24 Jun 1996 16:24:32  $
// $Author:   JHUCKINS  $
// 
// Log at end of file.
// 
// Module Name:	deventry.h
// Abstract:	CDeviceEntry Interface
// Environment:	Windows NT 3.51/4.0, MS Visual C++ 4.x
// Notes:
// 
////////////////////////////////////////////////////////////////////////////////

#ifndef deventry_h
#define deventry_h

#include "dlist.h"

// This is how a CDeviceObject gets registered with the CDriverObject object.
// This declaration will instantiate a CDeviceEntry object for your CDeviceObject.
#define DEFINE_DEVICE_ENTRY( Device ) CDeviceEntry g_Device##Device;

// This is to be done in the OnInitialize() call.  This will add the 
// device to the CDriverObject's list.
#define REGISTER_DEVICE_ENTRY( DeviceObject, Device ) \
	g_Device##Device.AssignDevice( (CDeviceObject*) DeviceObject ); \
	CDriverObject::AddDriverDevice( g_Device##Device );

// forward declarations
class CDeviceObject;

class CDeviceEntry : public CDListEntry
{
public:
	CDeviceEntry( const CDeviceEntry& Entry );
	CDeviceEntry( CDeviceObject* DeviceObject = NULL );

	VOID AssignDevice( CDeviceObject* DeviceObject );
	CDeviceObject* GetDevice( VOID );

private:
	CDeviceObject*	m_DeviceObject;
};

////////////////////////////////////////////////////////////////////////////////
// inlines
//

CDeviceEntry::CDeviceEntry( CDeviceObject* DeviceObject /* = NULL */ )
 	:	m_DeviceObject( DeviceObject )
 {
	return;
 }

VOID CDeviceEntry::AssignDevice( CDeviceObject* DeviceObject )
{
	m_DeviceObject = DeviceObject;
	return;
}

CDeviceObject* CDeviceEntry::GetDevice( VOID )
{
	return m_DeviceObject;
}

#endif deventry_h
