////////////////////////////////////////////////////////////////////////////////
// $Header:   S:\3x\src\ntkm\ntdevpp\sampdrv\linteger.cpv   1.0   24 Jun 1996 16:24:26   JHUCKINS  $
// 
// INTEL Corporation Proprietary Information
// 
// This listing is supplied under the terms of a license agreement
// with INTEL Corporation and may not be copied nor disclosed except
// in accordance with the terms of that agreement.
// 
// Copyright (c) 1996 Intel Corporation. All rights reserved.
// 
// $Revision:   1.0  $
// $Date:   24 Jun 1996 16:24:26  $
// $Author:   JHUCKINS  $
// 
// Log at end of file.
// 
// Module Name:	linteger.cpp
// Abstract:	CLargeInteger implementation
// Environment:	Windows NT 3.51/4.0, MS Visual C++ 4.x
// Notes:
// 
////////////////////////////////////////////////////////////////////////////////

// disable some warnings
#pragma warning( disable: 4699 )	// Note: Creating precompiled header
#pragma warning( disable: 4201 )	// nameless struct/union
#pragma warning( disable: 4514 )	// unreferenced inline function has been removed

#include <idrivrpp.h>
#include "linteger.h"
#include "debug.h"

///////////////////////////////////////////////////////////////////////////////
// ctor/dtor
//
CLargeInteger::CLargeInteger( void )
	:	LowPart( m_LargeInteger.LowPart ),
		HighPart( m_LargeInteger.HighPart )
{
	m_LargeInteger.LowPart = 0;
	m_LargeInteger.HighPart = 0;
	return;
}

CLargeInteger::CLargeInteger( IN const LARGE_INTEGER Value )
	:	LowPart( m_LargeInteger.LowPart ),
		HighPart( m_LargeInteger.HighPart ),
		m_LargeInteger( Value )
{
	return;
}

CLargeInteger::CLargeInteger( IN const int Value )
	:	LowPart( m_LargeInteger.LowPart ),
		HighPart( m_LargeInteger.HighPart )
{
	m_LargeInteger.LowPart = Value;
	m_LargeInteger.HighPart = 0;
	return;
}

/////////////////////////////////////////////////////////////////////////////
// $Log:   S:\3x\src\ntkm\ntdevpp\sampdrv\linteger.cpv  $
// 
//    Rev 1.0   24 Jun 1996 16:24:26   JHUCKINS
// Initial revision.
// 
//    Rev 1.2   11 Jun 1996 11:29:50   JDELLIOT
// cleanup of naming
// 
//    Rev 1.1   31 May 1996 15:50:28   JDELLIOT
// added robustness features (ASSERT, TRACE, validation of params)
// cleanup
// restructure of some interfaces
// 
//    Rev 1.0   25 Apr 1996 14:07:26   JDELLIOT
// Initial revision.
// 
// 
