////////////////////////////////////////////////////////////////////////////////
// $Header:   S:\3x\src\ntkm\ntdevpp\sampdrv\regkey.h_v   1.0   24 Jun 1996 16:24:36   JHUCKINS  $
// 
// INTEL Corporation Proprietary Information
// 
// This listing is supplied under the terms of a license agreement
// with INTEL Corporation and may not be copied nor disclosed except
// in accordance with the terms of that agreement.
// 
// Copyright (c) 1996 Intel Corporation. All rights reserved.
// 
// $Revision:   1.0  $
// $Date:   24 Jun 1996 16:24:36  $
// $Author:   JHUCKINS  $
// 
// Log at end of file.
// 
// Module Name:	regkey.h
// Author:		Jeff Huckins
// Abstract:	CRegistryKey Interface
// Environment:	Windows NT 3.51/4.0, MS Visual C++ 4.x
// Notes:
// 
////////////////////////////////////////////////////////////////////////////////

#ifndef regkey_h
#define regkey_h

class CRegistryKey : public CNamedObject
{
public:
	// methods
	NTSTATUS Create(
		IN PCWSTR Name,
		IN PCWSTR RootDirectoryName,
		IN ACCESS_MASK DesiredAccess,
		OUT PULONG Disposition );
	NTSTATUS Create(
		IN CUnicodeString& Name,
		IN CUnicodeString& RootDirectoryName,
		IN ACCESS_MASK DesiredAccess,
		OUT PULONG Disposition );
	NTSTATUS Create(
		IN CUnicodeString& Name,
		IN ACCESS_MASK DesiredAccess,
		OUT PULONG Disposition );
	NTSTATUS Create(
		IN PCWSTR Name,
		IN ACCESS_MASK DesiredAccess,
		OUT PULONG Disposition );
	NTSTATUS Create( 
		IN CUnicodeString& Name,
		OUT PULONG Disposition );
	NTSTATUS Create( 
		IN PCWSTR Name,
		OUT PULONG Disposition );

	NTSTATUS Open( IN ACCESS_MASK DesiredAccess = KEY_ALL_ACCESS );
	NTSTATUS Delete( VOID );
	NTSTATUS Flush( VOID );
	NTSTATUS Query(
		IN KEY_INFORMATION_CLASS KeyInformationClass,
		OUT PVOID KeyInformation,
		IN ULONG Length,
		OUT PULONG ResultLength );
	NTSTATUS QueryValue(
		IN PUNICODE_STRING ValueName,
		IN KEY_VALUE_INFORMATION_CLASS KeyValueInformationClass,
		OUT PVOID KeyValueInformation,
		IN ULONG Length,
		OUT PULONG ResultLength );
	NTSTATUS QueryValueULONG( IN PUNICODE_STRING ValueName, OUT PULONG Value );
	NTSTATUS QueryValueString(
		IN PUNICODE_STRING ValueName,
		OUT CUnicodeString& Value );
	NTSTATUS SetValue(
		IN PUNICODE_STRING ValueName,
		IN ULONG Type,
		IN PVOID Data,
		IN ULONG DataSize );
	NTSTATUS SetValueULONG( IN PUNICODE_STRING ValueName, IN ULONG Value );
	NTSTATUS SetValueString(
		IN PUNICODE_STRING ValueName,
		IN PUNICODE_STRING Value );

	virtual BOOLEAN IsValid( VOID );

private:
	CFileObject m_RootDirectory;
};

////////////////////////////////////////////////////////////////////////////////
// inlines
//
inline NTSTATUS CRegistryKey::Delete( VOID )
{
	return ZwDeleteKey( m_Handle );
}

inline NTSTATUS CRegistryKey::Flush( VOID )
{
	return ZwFlushKey( m_Handle );
}

inline NTSTATUS CRegistryKey::Query(
	IN KEY_INFORMATION_CLASS KeyInformationClass,
	OUT PVOID KeyInformation,
	IN ULONG Length,
	OUT PULONG ResultLength )
{
	ASSERT( NULL != KeyInformation );
	ASSERT( NULL != ResultLength );

	return ZwQueryKey(
		m_Handle,
		KeyInformationClass,
		KeyInformation,
		Length,
		ResultLength );
}

inline NTSTATUS CRegistryKey::QueryValue(
	IN PUNICODE_STRING ValueName,
	IN KEY_VALUE_INFORMATION_CLASS KeyValueInformationClass,
	OUT PVOID KeyValueInformation,
	IN ULONG Length,
	OUT PULONG ResultLength )
{
	ASSERT( NULL != ValueName );
	ASSERT( NULL != KeyValueInformation );
	ASSERT( NULL != ResultLength );

	return ZwQueryValueKey(
		m_Handle,
		ValueName,
		KeyValueInformationClass,
		KeyValueInformation,
		Length,
		ResultLength );
}

inline NTSTATUS CRegistryKey::SetValue(
	IN PUNICODE_STRING ValueName,
	IN ULONG Type,
	IN PVOID Data,
	IN ULONG DataSize )
{
	ASSERT( NULL != ValueName );

	return ZwSetValueKey(
		m_Handle,
		ValueName,
		0,	// TitleIndex
		Type,
		Data,
		DataSize );
}

inline NTSTATUS CRegistryKey::SetValueULONG(
	IN PUNICODE_STRING ValueName,
	IN ULONG Value )
{
	return SetValue( ValueName, REG_DWORD, &Value, sizeof Value );
}

inline NTSTATUS CRegistryKey::SetValueString(
	IN PUNICODE_STRING ValueName,
	IN PUNICODE_STRING Value )
{
	ASSERT( NULL != Value );

	return SetValue(
		ValueName,
		REG_SZ,
		Value->Buffer,
		Value->Length + sizeof WCHAR );
}

#endif regkey_h

/*******************************************************************************
 * $Log:   S:\3x\src\ntkm\ntdevpp\sampdrv\regkey.h_v  $
 * 
 *    Rev 1.0   24 Jun 1996 16:24:36   JHUCKINS
 * Initial revision.
 * 
 *    Rev 1.6   03 Jun 1996 07:47:12   JHUCKINS
 * Added Author to file header
 * 
 *    Rev 1.5   02 Jun 1996 15:59:12   JHUCKINS
 * Added Create Members
 * 
 *    Rev 1.4   31 May 1996 15:50:48   JDELLIOT
 * added robustness features (ASSERT, TRACE, validation of params)
 * cleanup
 * restructure of some interfaces
 *
 */

