//	******************************************************
//	*  Module Name:	SAMPDRV.CPP
//	*  Abstract:	CSampleDriver class implementation
//	*  Environment:
//	*
//	*  Notes:
//	* <Assumptions>
//	* <Other of interest>
//	*
//	******************************************************
#pragma warning (disable : 4201 )
#pragma warning (disable : 4514 )
#pragma warning (disable : 4699 )

#include "sampdev.h"

// driver
#include "sampdrv.h"
#include "debug.h"

#define DEVICE_NAME L"\\Device\\SAMPLE"
#define WIN32DEVICE_NAME L"\\DosDevices\\SAMPLE"
#define DRIVER_CLASSNAME L"AudioAccelerator"

SampleDriver g_Driver;
#ifdef _DEBUG
	char szDebugName[] = "SampleDevice";
#endif

// Class SampleDriver 
SampleDriver::SampleDriver()
	: CDriverObject( DRIVER_CLASSNAME )
{
}

SampleDriver::~SampleDriver()
{
}

NTSTATUS SampleDriver::OnInitialize(PUNICODE_STRING RegistryPath)
{
	TRACE("SampleDriver::OnInitialize");

	return CDriverObject::OnInitialize( RegistryPath );
}

VOID SampleDriver::OnUnload()
{
	TRACE("SampleDriver::OnUnLoad");
	CDriverObject::OnUnload();
}

NTSTATUS SampleDriver::CreateDevices()
{
	UNICODE_STRING	DeviceName,
					Win32DeviceName;
	NTSTATUS		status;

	TRACE("SampleDriver::CreateDevice entered");

	RtlInitUnicodeString( &DeviceName, DEVICE_NAME );
	RtlInitUnicodeString( &Win32DeviceName, WIN32DEVICE_NAME );

	// Call new for each CDeviceObject that needs to be instantiated.
	new( *this, 
		&DeviceName,
		&Win32DeviceName,
		FILE_DEVICE_UNKNOWN,
		0,
		FALSE,
		status ) CSampleDevice(this);

	return status;
}
