////////////////////////////////////////////////////////////////////////////////
// $Header:   S:\3x\src\ntkm\ntdevpp\sampdrv\thread.cpv   1.0   24 Jun 1996 16:24:28   JHUCKINS  $
// 
// INTEL Corporation Proprietary Information
// 
// This listing is supplied under the terms of a license agreement
// with INTEL Corporation and may not be copied nor disclosed except
// in accordance with the terms of that agreement.
// 
// Copyright (c) 1996 Intel Corporation. All rights reserved.
// 
// $Revision:   1.0  $
// $Date:   24 Jun 1996 16:24:28  $
// $Author:   JHUCKINS  $
// 
// Log at end of file.
// 
// Module Name:	thread.cpp
// Author:		Jeff Huckins
// Abstract:	CThread implementation
// Environment:	Windows NT 3.51/4.0, MS Visual C++ 4.x
// Notes:
// 
////////////////////////////////////////////////////////////////////////////////

#pragma warning( disable: 4201 )	// nonstandard extension used : nameless struct/union
#pragma warning( disable: 4514 )	// unreferenced inline function has been removed

#include <idrivrpp.h>
#include "debug.h"

NTSTATUS CThread::GetObjectPtr( IN PVOID& Object )
{
	NTSTATUS Status = (NULL == m_ObjectPtr) ?
		ReferenceObjectByHandle( THREAD_ALL_ACCESS ) : STATUS_SUCCESS;
	Object = m_ObjectPtr;
	return Status;
}

VOID CThread::OnTerminate( IN PVOID /* TerminateContext */ )
{
	// do nothing
	return;
}

VOID CThread::StartRoutine( IN CThread* This )
{
	// start the thread
	ASSERT( NULL != This );
	This->m_ExitStatus = This->OnStart( This->m_StartContext );

	// let the most-derived cleanup
	This->OnTerminate( This->m_TerminationContext );

	// terminate this thread
	Terminate( This->m_ExitStatus );

	return;
}

////////////////////////////////////////////////////////////////////////////////
// $Log:   S:\3x\src\ntkm\ntdevpp\sampdrv\thread.cpv  $
// 
//    Rev 1.0   24 Jun 1996 16:24:28   JHUCKINS
// Initial revision.
// 
//    Rev 1.7   03 Jun 1996 07:47:10   JHUCKINS
// Added Author to file header
// 
//    Rev 1.6   31 May 1996 15:50:34   JDELLIOT
// added robustness features (ASSERT, TRACE, validation of params)
// cleanup
// restructure of some interfaces
// 
//    Rev 1.5   13 May 1996 10:04:44   JHUCKINS
// c52 bootload complete
// 
//    Rev 1.4   10 May 1996 23:09:56   JHUCKINS
// implement CObject to derive CThread from
// 
//    Rev 1.3   02 May 1996 16:23:16   JHUCKINS
// Added TERMINATION_ROUTINE callback that is registered by owner object.
// 
//    Rev 1.2   02 May 1996 15:56:10   JHUCKINS
// Don't delete this
// 
//    Rev 1.1   01 May 1996 09:02:24   JHUCKINS
// Added virtual OnTerminate() method and m_bDynamic member so that the
// virtual OnTerminate() method can delete this object if it was dynamically
// allocated, as indicated by the constructor argument.
// 
//    Rev 1.0   30 Apr 1996 08:54:40   JHUCKINS
// Initial revision.
//
