////////////////////////////////////////////////////////////////////////////////
// $Header:   S:\3x\src\ntkm\ntdevpp\sampdrv\timeout.h_v   1.0   24 Jun 1996 16:24:34   JHUCKINS  $
// 
// INTEL Corporation Proprietary Information
// 
// This listing is supplied under the terms of a license agreement
// with INTEL Corporation and may not be copied nor disclosed except
// in accordance with the terms of that agreement.
// 
// Copyright (c) 1996 Intel Corporation. All rights reserved.
// 
// $Revision:   1.0  $
// $Date:   24 Jun 1996 16:24:34  $
// $Author:   JHUCKINS  $
// 
// Log at end of file.
// 
// Module Name:		timeout.h
// Abstract:		CTimeOut Inteface
// Environment:		Windows NT 3.51/4.0, MS Visual C++ 2.x
// Notes:
//	Time is expressed in 100ns increments
// 
////////////////////////////////////////////////////////////////////////////////

#ifndef timeout_h
#define timeout_h

#include <idrivrpp.h>

////////////////////////////////////////////////////////////////////////////////
// CTimeOut Interface
//
class CTimeOut
{
public:
	// ctor
//	CTimeOut( const __int64 TimeOut );
	CTimeOut( const CLargeInteger TimeOut );

	// methods
	void StartTimer( void );
	BOOLEAN IsExpired( void ) const;

private:
	// members

//	//@@@ can we use CLargeIntegers
//	__int64	m_TimeOut;
//	__int64	m_StartTime;

	CLargeInteger m_TimeOut;
	CLargeInteger m_StartTime;
};

////////////////////////////////////////////////////////////////////////////////
// inline functions
//
//inline CTimeOut::CTimeOut( const __int64 TimeOut )
inline CTimeOut::CTimeOut( const CLargeInteger TimeOut )
	: m_TimeOut( TimeOut )
{
//	KeQuerySystemTime( (LARGE_INTEGER*) &m_StartTime );
	KeQuerySystemTime( m_StartTime );
}

inline void CTimeOut::StartTimer( void )
{
//	KeQuerySystemTime( (LARGE_INTEGER*) &m_StartTime );
	KeQuerySystemTime( m_StartTime );
}

inline BOOLEAN CTimeOut::IsExpired( void ) const
{
//	__int64 CurrentTime;
	CLargeInteger CurrentTime;
//	KeQuerySystemTime( (LARGE_INTEGER*) &CurrentTime );
	KeQuerySystemTime( CurrentTime );
	return BOOLEAN( (CurrentTime - m_StartTime) > m_TimeOut );
}

#endif timeout_h

/******************************************************************************
 * $Log:   S:\3x\src\ntkm\ntdevpp\sampdrv\timeout.h_v  $
 * 
 *    Rev 1.0   24 Jun 1996 16:24:34   JHUCKINS
 * Initial revision.
 * 
 *    Rev 1.2   31 May 1996 15:50:32   JDELLIOT
 * added robustness features (ASSERT, TRACE, validation of params)
 * cleanup
 * restructure of some interfaces
 * 
 *    Rev 1.1   03 May 1996 11:57:48   JDELLIOT
 * converted to __int64
 * 
 *    Rev 1.0   30 Apr 1996 08:58:50   JDELLIOT
 * Initial revision.
 * 
 */
